from coralillo.datamodel import debyte_set


class PermissionHolder:

    def allow_key(self):
        ''' Gets the key associated with this user where we store permission
        information '''
        return '{}:{}:allow'.format(self.cls_key(), self.id)

    def allow(self, objspec, *, restrict=None):
        engine = type(self).get_engine()

        return engine.lua.allow(keys=[self.allow_key()], args=[objspec, restrict])

    def is_allowed(self, objspec, *, restrict=None):
        engine = type(self).get_engine()

        return engine.lua.is_allowed(keys=[self.allow_key()], args=[objspec, restrict])

    def revoke(self, objspec):
        engine = type(self).get_engine()

        return engine.redis.srem(self.allow_key(), objspec)

    def get_perms(self):
        engine = type(self).get_engine()

        return debyte_set(engine.redis.smembers(self.allow_key()))
